<?php
/**
 * @package Recent Forum Topics
 * @version 1.2
 * @Author: Pipke(AdemaStudios)
 * @copyright Copyright (C) 2014, Pipke
 *
 * This SMF modification is subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this SMF modification except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/   
 */

	if (!defined('SMF'))
		die('Hacking attempt...');

//Hooks
function rft_mod_admin(&$areas)
{
	global $txt;

	loadLanguage('RecentForumTopics');

	$areas['config']['areas']['modsettings']['subsections']['recentforumtopics'] = array($txt['rft_name']);
}

function rft_mod_settings(&$sub_actions)
{
	global $context;

	$sub_actions['recentforumtopics'] = 'rft_blockSettings';
}

function rft_blockSettings($return_config = false)
{
	global $context, $scripturl, $txt;

	$config_vars = array(
		array('desc', 'rft_topic_solvednote'),
		array('desc', 'rft_portalnote'),
		array('check', 'rft_enable', 'subtext' => $txt['rft_enable_sub'],),
		array('select', 'rft_numbertopics', array('3' => $txt['rft_3'],'4' => $txt['rft_4'],'5' => $txt['rft_5'],'6' => $txt['rft_6'],'7' => $txt['rft_7'],'8' => $txt['rft_8'],'9' => $txt['rft_9'],'10' => $txt['rft_10'],)),
		array('check', 'rft_disable_smfrecentposts'),
		array('select', 'rft_subject_topics', 'subtext' => $txt['rft_subject_topics_sub'], array('last' => $txt['rft_last'],'first' => $txt['rft_first'],)),
		array('select', 'rft_link_topics', 'subtext' => $txt['rft_link_topics_sub'], array('last' => $txt['rft_last'],'first' => $txt['rft_first'],)),		
		array('check', 'rft_linktree'),
		array('check', 'rft_counter_viewnumbers'), 
		array('int', 'rft_color_viewnumbers', 'subtext' => $txt['rft_color_viewnumbers_sub'], 'preinput' => '&#35;', 'size' => 7),
		array('check', 'rft_firstpostlinkicon'), 
		array('check', 'rft_lastpostlinkicon'),
		array('check', 'rft_firstcolumn'), 
		array('check', 'rft_secondcolumn'),
		array('check', 'rft_menubuttons'), 
		array('check', 'rft_postingicons'), 
		array('check', 'rft_topic_solved', 'subtext' => $txt['rft_topic_solved_sub']),
		array('check', 'rft_portal', 'subtext' => $txt['rft_portal_sub']),
	);

	if ($return_config)
		return $config_vars;

	$context['post_url'] = $scripturl . '?action=admin;area=modsettings;save;sa=recentforumtopics';
	$context['settings_title'] = $txt['rft_settings_title'];

	if (empty($config_vars))
	{
		$context['settings_save_dont_show'] = true;
		$context['settings_message'] = '<div align="center">' . $txt['modification_no_misc_settings'] . '</div>';

		return prepareDBSettingContext($config_vars);
	}

	if (isset($_GET['save']))
	{
		checkSession();
		if ((!empty($_POST['rft_color_viewnumbers'])) && (ctype_alnum($_POST['rft_color_viewnumbers']) === false))
			fatal_lang_error('rft_error_color', false);
		$save_vars = $config_vars;
		saveDBSettings($save_vars);
		redirectexit('action=admin;area=modsettings;sa=recentforumtopics');
	}

	prepareDBSettingContext($config_vars);
}


function rft_load_themes()
{
	global $context, $settings, $modSettings;

	loadLanguage('RecentForumTopics');

	if (in_array($context['current_action'], array('helpadmin', 'printpage')) || WIRELESS) return;

	if (!empty($modSettings['rft_enable'])) {
		if (!empty($modSettings['rft_disable_smfrecentposts']))
			$settings['number_recent_posts'] = 0;
		RecentForumTopics_loading();
	}
}

//Show on index only (yes to collapse)
function RecentForumTopics_loading()
{
	global $context, $sourcedir, $txt, $scripturl, $modSettings, $settings, $boardurl, $boarddir;

	$current_action = ''; //all 
	
	if (((!empty($_REQUEST['action']) && ($_REQUEST['action'] != 'forum')) && ($_REQUEST['action'] != 'collapse')) || !empty($_REQUEST['topic']) || !empty($_REQUEST['board']) || !empty($_REQUEST['page']) || !empty($_REQUEST['blog']))
		$current_action = 'dontshowme';
	
	if (!empty($modSettings['rft_portal']) && (empty($_REQUEST['action'])))
	$current_action = 'dontshowme';
	
	if(!empty($current_action))
		return;

	$context['html_headers'] .= '
		<style type="text/css">
			.topic_table td.stickybg2
			{
			background-position: 96% 6px;
			}
			.topic_table td.lockedbg2
			{
			background-position: 96% 6px;
			}
			.topic_table td.locked_sticky2
			{
			background-position: 96% 6px;
			}
		</style>';
		
	require_once($sourcedir . '/RecentForumTopics.php');
	
	rft_mainbasic();
		
	loadTemplate('RecentForumTopics');
	
	//$context['page_title'] = $txt['page_title'];
	if (!empty($modSettings['rft_linktree']))
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=forum',
		'name' => $txt['rft_name']
	);
	
	$context['template_layers'][] = 'rft';
}

/* DUH! WINNING! */
function rft_copyright(&$dummy)
{
	global $context;
	if (isset($context['current_action']) && $context['current_action'] == 'credits')
	$context['copyrights']['mods'][] = 'Recent Forum Topics Mod | <a href="http://www.simplemachines.org/community/index.php?action=profile;u=314795" title="AdemaStudios">&copy 2014 by Pipke</a>';
}

?>