<?php
/**
 * @package Recent Forum Topics
 * @version 1.2
 * @Author: Pipke(AdemaStudios)
 * @copyright Copyright (C) 2014, Pipke
 *
 * This SMF modification is subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this SMF modification except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/   
 */

if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
	require_once(dirname(__FILE__) . '/SSI.php');
elseif (!defined('SMF'))
	exit('<b>Error:</b> Cannot install - please verify you put this in the same place as SMF\'s index.php.');

global $modSettings;
// Adding default mod settings to the database
$mod_settings = array(
		'rft_enable' => 0,
		'rft_numbertopics' => 10,
		'rft_subject_topics' => 'last',
		'rft_link_topics' => 'last',
		'rft_disable_smfrecentposts' => 1,
		'rft_link_topics' => 1,
		'rft_linktree' => 1,
		'rft_counter_viewnumbers' => 1, 
		'rft_color_viewnumbers' => '444',
		'rft_firstpostlinkicon' => 1, 
		'rft_lastpostlinkicon' => 1,
		'rft_firstcolumn' => 1,
		'rft_secondcolumn' => 1,
		'rft_menubuttons' => 1, 
		'rft_postingicons' => 1,
		'rft_topic_solved' => 0,
		'rft_portal' => 0,
);

updateSettings($mod_settings);

$hooks = array(
	'integrate_pre_include' => '$sourcedir/Subs-RecentForumTopics.php',
	'integrate_modify_modifications' => 'rft_mod_settings',
	'integrate_admin_areas' => 'rft_mod_admin',
	'integrate_load_theme' => 'rft_load_themes',
	'integrate_menu_buttons' => 'rft_copyright',
	);

foreach ($hooks as $hook => $function)
	add_integration_function($hook, $function);

?>